#!/usr/bin/perl

# suprnova light 2 - create your own suprnova mirror
# Copyright (C) 2004 ntworks.net
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details:
# http://www.gnu.org/copyleft/gpl.html
#
# dl.cgi is part of the suprnova light 2 scripts.
# Get the latest version at http://suprnova.ntworks.net/
# Send patches and comments to snlight2@ntworks.net 

# change the path to your configuration file
my $confFile = '/path/to/your/snmirror.conf';

# don't change anything below this line ########################################################

use LWP::UserAgent;

my %conf = getConfiguration ();
my $mirrorFile = $conf {'basedir'} . '/' . $conf {'mirrorfile'};

open (MIRRORS, $mirrorFile) || dieNice ("could not open mirrorfile $mirrorFile: $!\n");
my @mirrors = <MIRRORS>;
close MIRRORS;
my $randomMirror = $mirrors [rand @mirrors];
chomp ($randomMirror);

my $url = $ENV {'QUERY_STRING'};
my ($file) = ($url =~ /\/([^\/]+)$/);
dieNice ("Invalid URL") if !($url || $file);

my $ua = LWP::UserAgent -> new (
    agent => 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; .NET CLR 1.1.4322)'
);
$ua -> proxy ('http', $conf {'proxy'}) if (defined $conf {'proxy'}); 

my $response = $ua -> get (
    $url,
    "Referer"   => $randomMirror,
);

my $content = $response -> content;
dieNice ("Could not download torrent file") if !$content;
my $headers = $response -> headers;

print "Content-Type: application/x-bittorent\n";
print "Content-Disposition: attachment; filename=\"" . $file . "\"\n"; 
print 'Etag: ' . $headers -> header ('Etag') . "\n";
print 'Accept-Ranges: ' . $headers -> header ('Accept-ranges') . "\n";
print 'Content-Length: ' . $headers -> header ('Content-length') . "\n\n";
binmode STDOUT;
print $content;
exit;

sub dieNice {
    my $text = shift;
    print "Content-type: text/html\n\n";
    print "an error occurred: $text";
    exit;
}

sub getConfiguration {
    my %conf;
    open (CONF, $confFile) || dieNice ("could not open configuration $confFile: $!\n");
    while (<CONF>) {
        chomp;
        if ((! /^#/) && ($_)) {
            /\s*(\S*)=(.*)/;
            $conf {$1} = $2;
        }
    }
    close CONF;
    %conf;
}
