#!/usr/bin/perl

# suprnova light 2 - create your own suprnova mirror
# Copyright (C) 2004 ntworks.net
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details:
# http://www.gnu.org/copyleft/gpl.html
#
# search.cgi is part of the suprnova light 2 scripts.
# Get the latest version at http://suprnova.ntworks.net/
# Send patches and comments to snlight2@ntworks.net 

# change the path to your configuration file
my $confFile = '/path/to/your/snmirror.conf'; 

# don't change anything below this line ###########################################################

print "Content-type: text/html\n\n";

use CGI::Carp qw(fatalsToBrowser);
use strict;
use CGI;

my %conf = getConfiguration ();
my %cats = getCategories ();

my $available = keys %cats;

my $disabled;
if ($available == 0) {
    $disabled = ' disabled="disabled"';
}

my $query = new CGI;
my $q = $query -> param ('q');
my $c = $query -> param ('category');
my $s = $query -> param ('seedless');
my $t = $query -> param ('type');

my ($files, $seeds, $slHideSelected, $slShowSelected, $phrase, $cmd, $jss);
my ($phraseSelected, $allSelected, $anySelected, @words, $query, $re, $first);

if (length ($q) > 3) {
    if ($c eq 'all') { $files = '*.htm' }
    else { $files = getCategoryFiles ($c) }
    
    if ($s eq 'hide') {
        $seeds = '.*<span class=\\"green\\">.*';
        $slHideSelected = ' selected="selected"';
        $slShowSelected = '';
    }
    else {
        $seeds = '.*<span class=\\"(green|red)\\">.*';
        $slHideSelected = '';
        $slShowSelected = ' selected="selected"';
    }
    
    if ($t eq 'phrase') {
        $phrase = quotemeta ($q);
        $cmd = 'grep -h -i -E  "^<tr><td class=\\"time\\">.*<a href=.*>.*' . $phrase .
            '.*</a>' . $seeds . '" ' . $files;
        $phraseSelected = ' selected="selected"';
        $allSelected = '';
        $anySelected = '';
    }
    elsif ($t eq 'any') {
        $query = quotemeta ($q);
        @words = split (/\\ /, $query, 5);
        $re = join ('|', @words);
        $cmd = 'grep -h -i -E  "^<tr><td class=\"time\">.*<a href=.*>.*(' . $re .
            ').*</a>' . $seeds . '" ' . $files;
        $phraseSelected = '';
        $allSelected = '';
        $anySelected = ' selected="selected"';
    }
    elsif ($t eq 'all') {
        $query = quotemeta ($q);
        @words = split (/\\ /, $query, 5);
        $first = shift @words;
        $cmd = 'grep -h -i -E  "^<tr><td class=\"time\">.*<a href=.*>.*' . $first .
            '.*</a>' . $seeds . '" ' . $files;
        foreach my $word (@words) {
            $cmd .= ' | grep -h -i -E  "^<tr><td class=\"time\">.*<a href=.*>.*' . $word .
                '.*</a>"';
        }
        $phraseSelected = '';
        $allSelected = ' selected="selected"';
        $anySelected = '';
    }
}
else {
    $phraseSelected = ' selected="selected"';
    $allSelected = '';
    $anySelected = '';
    $slHideSelected = '';
    $slShowSelected = ' selected="selected"';
}

if ($conf {'jssort'} eq 'yes') { $jss = '<script src="tablesort.js" type="text/javascript"></script>' }
else { $jss = '' }

print <<"_EOT_";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><title>suprnova light &sup2;</title><link rel="stylesheet" type="text/css" media="screen" href="style.css" />
<link rel="shortcut icon" href="favicon.ico" /><meta name="robots" content="noindex,nofollow,noarchive" />$jss</head>
<body><table class="header"><tr><td class="header">suprnova light <span class="top">2</span></td>
<td class="generated">search in local archive only</td></tr><tr class="nav"><td class="nav">
<a href="index.htm">New Torrents</a><a href="categories.htm">Categories</a><a href="search.cgi">Search</a>
<a href="info.htm">Status</a></td></tr><tr class="note"><td colspan="2"><b>Note:</b> This is neither an official
suprnova.org mirror, nor is it intended for public use. <a href="notes.htm">Read more about suprnova light &sup2;...</a>
</td></tr></table><form method="post" action="search.cgi" enctype="text/multipart"><table class="search"><tr>
<td>Search suprnova light <span class="top">2</span>:</td><td>
<input type="text" name="q" value="$q" maxlength="20" size="20" class="text"$disabled />
<input type="submit" name="submit" value="go!" class="submit"$disabled /></td></tr><tr><td>&nbsp;</td><td>
<select name="type"$disabled><option value="phrase"$phraseSelected>exact phrase</option>
<option value="all"$allSelected>all words</option><option value="any"$anySelected>any word</option></select>
<select name="seedless"$disabled><option value="show"$slShowSelected>show all results</option>
<option value="hide"$slHideSelected>hide seedless</option></select><select name="category"$disabled>
<option value="all">all categories</option>
_EOT_

foreach (keys %cats) {
    my $selected;
    if ($_ eq $c) { $selected = ' selected="selected"' }
    else { $selected = '' }
    print "<option value=\"$_\"$selected>$_</option>";
}

print "</select></td></tr></table></form>";

if (length ($q) > 3) {
    if ($conf {'jssort'} eq 'yes') {
        print <<"        _EOT_";
        <table class="torrents"><thead><tr class="header"><th class="category" colspan="6"><a name="Search_result"></a>
        Search results for "$q":</th></tr><tr>
        <td class="htime" onclick="sortTable('torrents',0)" title="click to order by date">Since
        <img alt="ns" id="img_torrents_0" src="nosort.gif" /></td>
        <td class="htorrent" onclick="sortTable('torrents',1)" title="click to order by name">Torrents
        <img alt="ns" id="img_torrents_1" src="nosort.gif" /></td>
        <td class="hsize" onclick="sortTable('torrents',2)" title="click to order by size">Filesize
        <img alt="ns" id="img_torrents_2" src="nosort.gif" /></td>
        <td class="hseeds" onclick="sortTable('torrents',3)" title="click to order by seeds">Seeds
        <img alt="ns" id="img_torrents_3" src="nosort.gif" /></td>
        <td class="hdls" onclick="sortTable('torrents',4)" title="click to order by downloads">DLs
        <img alt="ns" id="img_torrents_4" src="nosort.gif" /></td>
        <td class="hkind" onclick="sortTable('torrents',5)" title="click to order by type">Type
        <img alt="ns" id="img_torrents_5" src="nosort.gif" /></td>
        </tr></thead><tbody id="torrents">
        _EOT_
    }
    else {
        print <<"        _EOT_";
        <table class="torrents"><thead><tr class="header"><th class="category" colspan="6"><a name="Search_result"></a>
        Search results for "$q":</th></tr><tr>
        <td class="htime">Since</td><td class="htorrent">Torrents</td><td class="hsize">Filesize</td>
        <td class="hseeds">Seeds</td><td class="hdls">DLs</td><td class="hkind">Type</td>
        </tr></thead><tbody id="torrents">
        _EOT_
    }
    chdir ($conf {'htmldir'});
    my $out = `$cmd`;
    print "$out</tbody></table>";
}
else {
    if ($available == 0) {
        print << "        _EOT_";
        <p>
            <b style="color: #292a86;">Search function is not available.</b><br /><br />
            The search function is not available because there are no categories mirrored.
        </p>
        _EOT_
    }
    else {
        print << "        _EOT_";
        <p>
            <b style="color: #292a86;">Notes:</b><br /><br />
            Enter any substring with at least four letters. 'exact phrase' searches for all torrents containing
            the string you entered, 'all words' searches for all torrents containing all words you entered in
            any order, 'any word' searches for all torrents containing at least one word you entered.<br />
            If there is no category to select (only the 'all categories' entry) there are no categories available
            on this mirror and you will get no results.<br /><br />
            You will not find any torrent listed only on the new torrent pages with this search.
        </p>
        _EOT_
    }
}

print <<"_EOT_";
<div class="copyright">Copyright &copy; 2004 by <a href="http://suprnova.ntworks.net/">ntworks.net</a> - The
<a href="http://bitconjurer.org/BitTorrent/">BitTorrent</a> protocol and original client and tracker written by
Bram Cohen.</div></body></html>
_EOT_

sub dieNice {
    my $text = shift;
    print $text;
    exit;
}
sub getConfiguration {
    my %conf;
    open (CONF, $confFile) || dieNice ("could not open configuration $confFile: $!\n");
    while (<CONF>) {
        chomp;
        if ((! /^#/) && ($_)) {
            /\s*(\S*)=(.*)/;
            $conf {$1} = $2;
        }
    }
    close CONF;
    %conf;
}
sub getCategories {
    my %cats;
    open (CAT, "$conf{basedir}/$conf{categoryfile}") || dieNice ("could not open categoryfile");
    while (<CAT>) {
        chomp;
        if (length > 4) {
            my ($tempCat, $tempFiles) = split /\t/;
            $cats {$tempCat} = $tempFiles;
        }
    }
    close CAT;
    %cats;
}
sub getCategoryFiles {
    my ($category) = shift || return undef;
    my @allIndexes = split (/ /, $cats {$category});
    my @allFiles;
    push @allFiles, "$_.htm" foreach (@allIndexes);
    my $fileStr = join (' ', @allFiles);
    $fileStr;
}
