/*
# suprnova light 2 - create your own suprnova mirror
# Copyright (C) 2004 ntworks.net
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details:
# http://www.gnu.org/copyleft/gpl.html
#
# tablesort.js is part of the suprnova light 2 scripts.
# Get the latest version at http://suprnova.ntworks.net/
# Send patches and comments to snlight2@ntworks.net
*/
var sortCol = "ns";

if (document.ELEMENT_NODE == null) {
    document.ELEMENT_NODE = 1;
    document.TEXT_NODE = 3;
}

function getTextValue (el) {
    var i;
    var s;
    s = "";
    for (i = 0; i < el.childNodes.length; i++)
        if (el.childNodes[i].nodeType == document.TEXT_NODE)
            s += el.childNodes[i].nodeValue;
        else if (el.childNodes[i].nodeType == document.ELEMENT_NODE && el.childNodes[i].tagName == "BR")
            s += " ";
        else s += getTextValue(el.childNodes[i]);
    return s;
}

function compareValues (v1, v2) {
    if (v1 == v2) return 0;
    if (v1 > v2)  return 1;
    return -1;
}

function sortTable (id, column) {
    table = document.getElementById (id);
    if (table.reverseSort == null)
        table.reverseSort = new Array (true, false, true, true, true, false);
    if (column == table.prevColumn) table.reverseSort[column] = ! table.reverseSort[column];
    table.prevColumn = column;
    insertSort (table.rows, table.rows.length, column);
    img = document.getElementById ("img_" + id + "_" + column);
    if (img.alt == "ds") {
        img.src = "asc.gif";
        img.alt = "as";
    }
    else if (img.alt == "as") {
        img.src = "desc.gif";
        img.alt = "ds";
    }
    else if (img.alt == "ns") {
        if (! table.reverseSort[column]) {
            img.src = "asc.gif";
            img.alt = "as";
        }
        else {
            img.src = "desc.gif";
            img.alt = "ds";
        }
    }
    if ((sortCol != "ns") && (column != sortCol)) {
        img = document.getElementById ("img_" + id + "_" + sortCol);
        img.src = "nosort.gif";
        img.alt = "ns";
    }
    sortCol = column;
}

function insertSort (l, n, col) {
    var pointer;
    var temp;
    var f;
    var cmp;
    var ar = new Array ();
    for (var j = 0; j < n; j++) {
        ar[j] = getTextValue (l[j].cells[col]).toLowerCase ();
        f = parseFloat (ar[j]);
        if (! isNaN (f) && col != 1)
            if (ar[j].charAt (2) == "-")
                ar[j] = new Date (0, ar[j].split("-")[1], ar[j].split("-")[0]);
            else if (ar[j].charAt(2) == ":")
                ar[j] = new Date (0, 0, 1, ar[j].split(":")[0], ar[j].split(":")[1]);
            else ar[j] = f;
    }
    for (var i = 1; i < n; i++) {
        pointer = i-1;
        temp = ar[i];
        cmp = compareValues (temp, ar[pointer], col);
        if (table.reverseSort[col]) cmp = -cmp;
        while ((pointer >= 0) && (cmp < 0)) {
            ar[pointer+1] = ar[pointer];
            pointer--;
            cmp = compareValues (temp, ar[pointer]);
            if (table.reverseSort[col]) cmp = -cmp;
        }
        if (pointer < (i-1)) {
            table.insertBefore (table.removeChild(l[i]), l[pointer+1]);
            ar[pointer+1] = temp;
        }
    }
}
